/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2001-2008 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2008 GJ Designing Center Printer Business Group
 *                                          RICOH COMPANY,LTD. JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  $Id: target_serial.h 1817 2010-07-01 02:43:43Z mit-kimai $
 */

/*
 *	ꥢI/OǥХSIO˥ɥ饤СʽŻ̾ AKIH8_3048Fѡ
 *	ץå¢SCIѤ롣
 *
 *	target_serial.cμΤPDICˤ롣
 */

#ifndef TOPPERS_TARGET_SERIAL_H
#define TOPPERS_TARGET_SERIAL_H

#include "akih8_3048f.h"

/* 顼ߤϳߤ̤ϥȤ򳰤*/
#if 1
#define TOPPERS_H8_CFG_SCI_ERR_HANDLER
#endif

/*
 *  ݡֹγ
 *
 *ݡȿΤȤ
 *ܡȣ(SCI1)ƥݡȡʸ
 *ݡȿΤȤ
 *ܡȣ(SCI1)ƥݡȡ桼ݡǽ
 *ܡȣ(SCI0)Ʊ
 */

/*
 *  SIOγߥϥɥΥ٥ֹ
 */

/*  ݡȣSCI1  */
#define INHNO_SERIAL_IN		TINTNO_RXI1 /* ߥϥɥֹ */
#define INTNO_SERIAL_IN		TINTNO_RXI1 /* ֹ */

#define INHNO_SERIAL_OUT	TINTNO_TXI1 /* ߥϥɥֹ */
#define INTNO_SERIAL_OUT	TINTNO_TXI1 /* ֹ */

#define INHNO_SERIAL_ERR	TINTNO_ERI1 /* ߥϥɥֹ */
#define INTNO_SERIAL_ERR	TINTNO_ERI1 /* ֹ */

#define INTPRI_SIO      	(-1)     /* ͥ */
#define INTATR_SIO       	0U       /* ° */


#if TNUM_SIOP_H8_SCI >= 2
/*  ݡȣSCI0  */
#define INHNO_SERIAL2_IN	TINTNO_RXI0 /* ߥϥɥֹ */
#define INTNO_SERIAL2_IN	TINTNO_RXI0 /* ֹ */

#define INHNO_SERIAL2_OUT	TINTNO_TXI0 /* ߥϥɥֹ */
#define INTNO_SERIAL2_OUT	TINTNO_TXI0 /* ֹ */

#define INHNO_SERIAL2_ERR	TINTNO_ERI0 /* ߥϥɥֹ */
#define INTNO_SERIAL2_ERR	TINTNO_ERI0 /* ֹ */

#define INTPRI_SIO2			(-1)	/* ͥ */
#define INTATR_SIO2			0U		/* ° */

#endif	/* of #if TNUM_SIOP_H8_SCI >= 2 */

/*
 *  SYSTEM  SCI 
 */

#define SYSTEM_SCI		H8SCI1

#define SYSTEM_SCI_SMR		0
			/* եޥå				*/
	     	/* 		ĴƱ					*/
	     	/* 		饯󥰥8ӥå	*/
	     	/* 		ѥƥʤ				*/
	     	/* 		ȥåץӥåȥ󥰥1	*/
	     	/* 		å쥯ȡʬ:1*/

#if TNUM_SIOP_H8_SCI >= 2

#define USER_SCI		H8SCI0

#define USER_SCI_SMR		0
			/* եޥå				*/
	     	/* 		ĴƱ					*/
	     	/* 		饯󥰥8ӥå	*/
	     	/* 		ѥƥʤ				*/
	     	/* 		ȥåץӥåȥ󥰥1	*/
	     	/* 		å쥯ȡʬ:1*/

#endif	/* of #if TNUM_SIOP_H8_SCI >= 2 */

/*
 *  PDICΥ󥯥롼ɥե򥤥󥯥롼
 */
#include "pdic/h8/h8_sci.h"


#ifndef TOPPERS_MACRO_ONLY

/*
 *  SIOɥ饤Фν
 */
#define sio_initialize		h8_sci_initialize

/*
 *  ꥢI/OݡȤΥץ
 *      ǥХ¸Υץ
 *      ꥢI/OߤζػߡĤGDICԤ
 */
#define sio_opn_por(siopid, exinf)	h8_sci_opn_por(siopid, exinf)

/*
 *  ꥢI/OݡȤΥ
 *      ǥХ¸Υ
 */
#define sio_cls_por(p_siopcb)	h8_sci_cls_por(p_siopcb)

/*
 *  SIOγߥϥɥ
 */
#define sio_tx_isr	h8_sci_tx_isr
#define sio_rx_isr	h8_sci_rx_isr
#define sio_err_isr	h8_sci_err_isr

/*
 *  ꥢI/OݡȤؤʸ
 */
#define sio_snd_chr(siopcb, c)	h8_sci_snd_chr(siopcb, c)

/*
 *  ꥢI/OݡȤʸ
 */
#define sio_rcv_chr(siopcb)		h8_sci_rcv_chr(siopcb)


/*
 *  ꥢI/OݡȤΥХåε
 */
#define sio_ena_cbr(siopcb, cbrtn)	h8_sci_ena_cbr(siopcb, cbrtn)

/*
 *  ꥢI/OݡȤΥХåζػ
 */
#define sio_dis_cbr(siopcb, cbrtn)	h8_sci_dis_cbr(siopcb, cbrtn)

/*
 *  ꥢI/OݡȤǽХå
 */
#define h8_sci_irdy_snd(exinf)		sio_irdy_snd(exinf)
extern void sio_irdy_snd(intptr_t exinf);

/*
 *  ꥢI/OݡȤμΥХå
 */
#define h8_sci_irdy_rcv(exinf)		sio_irdy_rcv(exinf)
extern void sio_irdy_rcv(intptr_t exinf);

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_TARGET_SERIAL_H */
