/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2001-2010 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2008 GJ Designing Center Printer Business Group
 *                                          RICOH COMPANY,LTD. JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  $Id: core_support.S 1913 2010-09-08 08:14:50Z mit-kimai $
 */

/*
 *		ƥ¸⥸塼 ֥H8/300Hѡ
 */

#define	TOPPERS_MACRO_ONLY
#define TOPPERS_LABEL_ASM
#define UINT32_C(val)		(val)		/* uint32_tޥ */
#define ULONG_C(val)		(val)		/* ulong_tޥ */
#define CAST(type, val)		(val)		/* 㥹ȤԤޥ */
#include "kernel_impl.h"
#include "offset.h"
#include "target_config.h"

#ifdef OMIT_LOG_INH_TARGET_TIMER
#include "target_timer.h"				/*  INHNO_TIMER  */
#endif	/* OMIT_LOG_INH_TARGET_TIMER */

	.h8300h

/*
 *  ǥѥå
 *  Υ롼ϡ
 *  ƥ
 *  CPUå
 *  ʥǥΡ˳ͥ٥ޥ
 *  ǥѥåľ
 *  ǸƤӽФ롥
 *
 *  ؿƤӽФΥ쥸ݾڵ§
 *    ݾڤʤ쥸er0er1
 *    regparam=3ץˤer0er2
 *    ݾڤ쥸er2er6
 *    regparam=3ץˤer3er6
 *
 *¦ݤer2Ϥɤξ¸롣
 *C롼ƤӽФ
 *C롼󤫤ƤӽФ
 */
	.text
	.align 2
	.globl _dispatch
_dispatch:
	push.l	er2			/*  er26¸ */
	push.l	er3
	push.l	er4
	push.l	er5
	push.l	er6
	mov.l	@_p_runtsk, er0		/* er0 <- p_runtsk */
	mov.l	sp, @(TCB_sp, er0)	/* åݥ󥿤¸ */
	mov.l	#dispatch_r, er1	/* ¹ԺƳ */
	mov.l	er1, @(TCB_pc, er0)
	bra     dispatcher

/*
 *  dispatcher
 *  ˤdispatcheräƤΤǡ
 *er0ˤp_runtskƤƤ롣
 */
dispatch_r:
	pop.l	er6			/* er26 */
	pop.l	er5
	pop.l	er4
	pop.l	er3
	pop.l	er2

/*
 *  㳰롼εư
 */
	mov.b	@(TCB_enatex, er0), r1l	/* p_runtsk->enatex Υå */
	btst	#TCB_enatex_bit, r1l	/* enatexfalseʤ꥿ */
	beq	dispatch_r_1

	/*
	 *  p_runtsk->texptn Υå
	 *   texptnTEXPTNuint_t16ӥå
	 */
	mov.l	@(TCB_texptn, er0), er1
	beq	dispatch_r_1				/* texptn0Ǥʤ            */
	jmp	@_call_texrtn				/* 㳰롼θƽФ */

dispatch_r_1:
	rts								/* dispatch()θƤӽФإ꥿ */

/*
 *  ǥѥåưϡcore_support.S
 */
	.globl _start_dispatch
_start_dispatch:
	/*
	 *  Υ롼ϡͥ뵯ưˡ٤Ƥγߤػߤ
	 * ʳߥå֤ƱˤǸƤӽФ롥ޤߥ⡼ɡ
	 *  ƥȤƱˤǸƤӽФ뤳ȤꤷƤ롥
	 */
	mov.b   #0, r0l         		/* ߥͥȥ󥿤򥯥ꥢ */
	mov.b   r0l, @_intnest
	/*
	 *  CPUå֡ͥ٥ޥ֤ˤ
	 *
	 *  ȥåץ롼Υνǡlock_flagtrueˡ
	 *  saved_iipmIIPM_ENAALL˽Ƥ뤿ᡤͥ
	 *  ߤĤ뤳ȤǡCPUå֡ʥǥΡ˳
	 *  ͥ٥ޥ֤ˤʤ롥
	 *  ޤinitialize_taskdisdspfalse˽Ƥ뤿ᡤǥ
	 *  ѥåľ֤ˤʤäƤ롥
	 */
	jmp		dispatcher_0			/* ǥѥåΡdispatcherˤ */

/*
 *  ߤΥƥȤΤƤƥǥѥå
 *
 *  Υ롼ϡ
 *   ƥ
 *   CPUå
 *   ʥǥΡ˳ͥ٥ޥ
 *   ǥѥåľ
 *  ǸƤӽФ롥
 */
	.globl _exit_and_dispatch
_exit_and_dispatch:
	/* ǥѥåΡdispatcherˤ */

/*
 *  ǥѥå
 *  Υ롼ϡ
 *   ƥ
 *   CPUå
 *   ʥǥΡ˳ͥ٥ޥ
 *   ǥѥåľ
 *  ǸƤӽФ롥
 *
 *  ʤ
 *   ߥͥȥ󥿤0
 *   lock_flagtrue
 *   saved_iipmIIPM_ENAALL
 *   disdspfalse
 *   dspflgtrue
 *  ȤʤäƤ롥¹ԺƳϤؤ⤳ξ֤Τޤʬ롥
 */
dispatcher:
	/*
	 * p_runtskp_schedtskΤϣĤΰ̣롥
	 * (1) p_schedtsk != NULLξ
	 * ̾ΥڤؤԤ
	 * (2) p_schedtsk == NULLξ
	 * p_runtskNULLƤ
	 * dispatcher_1ʹߤγԤǳߤꡢ
	 * iget_tid()뤵줿ȤTSK_NONE֤
	 * ˤϡ¹Ծ֤Υʤˡp_runtskNULLˤ
	 * ɬפ롥)
	 */
#ifdef LOG_DSP_ENTER
	mov.l	@_p_runtsk, er0			/* p_runtskѥ᡼ */
	jsr	@_log_dsp_enter
#endif /* LOG_DSP_ENTER */
dispatcher_0:
	mov.l	@_p_schedtsk, er0		/* er0 <- p_schedtsk */
	mov.l	er0, @_p_runtsk			/* p_schedtskp_runtsk */
			/*  ¹Ԥ٤ʤСԤʬ */
	beq	dispatcher_1
	mov.l	@(TCB_sp, er0), sp
#ifdef LOG_DSP_LEAVE
	jsr @_log_dsp_leave
	mov.l	@_p_runtsk, er0			/* p_runtsk */
#endif /* LOG_DSP_LEAVE */
	mov.l	@(TCB_pc, er0), er1		/* ¹ԺƳϤ */
	jmp	@er1

	/*
	 *  ¹Ԥ٤ʤγԤ
	 *
	 *  󥿥ƥȤڤ괹Τϡȯ
	 *  ߽ˤɤΥåȤȤβȡߥϥɥ
	 *  ǤΥǥѥåɻߤȤĤΰ̣롥
	 */
dispatcher_1:
	/*
	 *  ߥǥͤɤ߹ΤϸΨΤǻѰդ
	 * r0 : 0x00
	 * r1 : 0x01
	 */
	sub.l	er0, er0
	mov.l   #1, er1

	/*
	 *  󥿥ƥȤڤؤ롥
	 */
	    		/* åߥåؤ */
	mov.l	@_istkpt, sp
				/* ߥͥȥ󥿤򣱤ˤ */
	mov.b   r1l, @_intnest

	/*
	 *  ߤĤ顢CPUå֤ˤʤ褦
	 *  CPUåե饰򥯥ꥢ
	 */
	mov.l   er0, @_lock_flag

dispatcher_2_enable_interrupt:
	/*
	 *ldc̿ľϳ߶ػߤǤꡢ׵᤬äƤ
	 *̿᤬¹Ԥ롣
	 *ʳߤäƤsleep륱Ϥʤ
	 */
	ldc.b     #H8ENAINT_ALL, ccr	/*  */
	sleep                           /* Ԥ */
	ldc.b     #IIPM_LOCK, ccr		/* ͥγߤػ */

	mov.l   @_reqflg, er2			/* reqflgΥå */
			/* reqflgBOOL -> int(32bits) */
			/* reqflg==NULLʤС⤦1ٳԤ */
	beq     dispatcher_2_enable_interrupt
	mov.l   er0, @_reqflg			/* reqflgΥꥢ */

	/*
	 *  ƥȤ᤹
	 *       ߥͥȥ󥿤򥯥ꥢ
	 */
	mov.b   r0l, @_intnest

	/*
	 *  CPUå֤᤹Ԥδ֤˼¹Ԥߥϥɥˤ
	 *  ꡤsaved_iipm񤭴ǽ뤿ᡤ᤹ͤɬ
	 *  פ롥dispatcher¹Ԥϡsaved_iipmIIPM_ENAALL
	 *  ȤʤäƤ뤿ᡤǤsaved_iipmIIPM_ENAALLʡ0ˤ᤻
	 *  Ф褤
	 *saved_iipm  0
	 *lock_flag  true
	 */
	mov.b   r0l, @_saved_iipm
	mov.l   er1, @_lock_flag
	bra		dispatcher_0

/*
 *  ߥϥɥ
 *װ˰ͤ餺̤ʬ
 *ʥե졼kernel_cfg_asm.Sˤ³
 *
 *ʲξ֤ǤˤäƤ
 *߶ػ
 *er0er3Ѥ
 *er2C롼Ƭɥ쥹
 *r3lߵĻ˳ߥޥꤹ
 *r3hߥϥɥֹ̤Ͽξ硢ޤϡ
 *										ȥ졼ǽͭʾ
 */
	.globl _common_interrupt_process
_common_interrupt_process:
	mov.b   @_intnest, r0l			/* ߥͥȥ󥿤Υå */
	bne     _interrupt_from_int     /* intnet0ǤʤС¿ųߤν */

	/*
	 *ʤγߤξ
	 *
	 *󥿥ƥȤڤؤ
	 *ߥͥȥ󥿢
	 *å
	 */
	mov.b   #1, r1l
	mov.b   r1l, @_intnest
	mov.l   sp, er0
    mov.l 	@_istkpt, sp
	push.l  er0                     /* åݥ󥿤 */

	ldc.b   r3l, ccr                /* ߵ */

#if defined(LOG_INH_ENTER) || defined(LOG_INH_LEAVE)
	sub.l	er0, er0				/* log_inh_enter/log_inh_leaveΰ  */
	mov.b	r3h, r0l				/* er0 <- ߥϥɥֹ */
#ifdef LOG_INH_LEAVE
	push.l  er0                     /* ߥϥɥֹ */
#endif	/*  LOG_INH_LEAVE  */
#endif	/* defined(LOG_INH_ENTER) || defined(LOG_INH_LEAVE) */

#ifdef LOG_INH_ENTER
#ifdef OMIT_LOG_INH_TARGET_TIMER
	cmp.b	#(INHNO_TIMER), r0l
	beq		_omit_log_inh_enter		/* Ʊʤ_omit_log_inh_enter */
#endif	/* OMIT_LOG_INH_TARGET_TIMER */
	push.l  er2                     /* C롼Ƭɥ쥹 */
	jsr		@_log_inh_enter
	pop.l   er2						/* C롼Ƭɥ쥹 */
_omit_log_inh_enter:
#endif	/*  LOG_INH_ENTER  */

	mov.l   sp, er0					/* CPU㳰ϥɥξΰp_excinf */
	jsr     @er2                    /* C롼ƤӽФ */

#ifdef LOG_INH_LEAVE
	pop.l   er0                     /* ߥϥɥֹ */
#ifdef OMIT_LOG_INH_TARGET_TIMER
	cmp.b	#(INHNO_TIMER), r0l
	beq		_omit_log_inh_leave		/* Ʊʤ_omit_log_inh_leave */
#endif	/* OMIT_LOG_INH_TARGET_TIMER */
	jsr		@_log_inh_leave
_omit_log_inh_leave:
#endif	/*  LOG_INH_LEAVE  */

	ldc.b   #IIPM_LOCK, ccr         /* ͥγ߶ػ */

	/*
	 *ƥȤڤؤ
	 *ߥͥȥ󥿢0
	 *å
	 */
	mov.b   #0, r0l
	mov.b   r0l, @_intnest
	mov.l   @sp, sp

	mov.l   @_reqflg, er0          /* reqflgΥå */
	beq     _ret_to_task_int       /* reqflgfalseʤ ret_to_task_int */
	bra     ret_int                /* иإ */

	/*
	 *¿ųߤξ
	 *߶ػߤǤˤäƤ
	 *
	 *ߥͥȥ󥿤Υ󥯥Ȥϰʲͳ
	 *άƤ
	 *ߤ2٥뤷ʤ
	 *CPU㳰򥵥ݡȤʤ
	 *exc_sense_context()ΤȤθʤƤɤ
	 */
_interrupt_from_int:
	/* ߥͥȥ󥿤Υ󥯥ȤϾά */
	ldc.b   r3l, ccr                /* ߵ */

#if defined(LOG_INH_ENTER) || defined(LOG_INH_LEAVE)
	sub.l	er0, er0				/* log_inh_enter/log_inh_leaveΰ  */
	mov.b	r3h, r0l				/* er0 <- ߥϥɥֹ */
#ifdef LOG_INH_LEAVE
	push.l  er0                     /* ߥϥɥֹ */
#endif	/*  LOG_INH_LEAVE  */
#endif	/* defined(LOG_INH_ENTER) || defined(LOG_INH_LEAVE) */

#ifdef LOG_INH_ENTER
	push.l  er2                     /* C롼Ƭɥ쥹 */
	jsr		@_log_inh_enter
	pop.l   er2						/* C롼Ƭɥ쥹 */
#endif	/*  LOG_INH_ENTER  */

	mov.l   sp, er0					/* CPU㳰ϥɥξΰp_excinf */
	jsr     @er2                    /* C롼ƤӽФ */

#ifdef LOG_INH_LEAVE
	pop.l   er0                     /* ߥϥɥֹ */
	jsr		@_log_inh_leave
#endif	/*  LOG_INH_LEAVE  */

	ldc.b   #IIPM_LOCK, ccr         /* ͥγ߶ػ */
	/* ߥͥȥ󥿤ΥǥȤϾά */

	/*
	 *Ϥ褬Ԥsleep̿ᤫɤΥ
	 *ɬפǤ롣ʤ⤷ߥϥɥreqflg=trueˤ
	 *ǥѥå㤬ƤФʤ᥿¹Ԥʤ
	 *H8ξ硢sleep̿ľˤߵĤldc̿μ¹ľ
	 *ϳ߶ػߤǤꡢ׵᤬äȤƤߤϼ
	 *դʤǡsleep̿᤬¹Ԥ롣Τᡢߤ
	 *äľsleep̿᤬¹Ԥ륱Ϲθʤɤ
	 */

	/*
	 *ǥѥåƤФˡ߸
	 */
_ret_to_task_int:
	/*
	 *  ߽Υ꥿ˤꡤCPUå֤˰ܹԤ褦
	 *  롥ͥ٥ޥϡRTE̿ˤ긵ͤ뤿ᡤ
	 *  lock_flagfalseˤƤФ褤lock_flagfalseˤΤϡ
	 *  CPUå֤Τޤ޳ߥϥɥ餫äкˡ
	 */
	sub.l	er0, er0
	mov.l   er0, @_lock_flag
				/* 쥸 */
	pop.l   er3
	pop.l   er2
	pop.l   er1
	pop.l   er0
	rte			/* ߸إ꥿ */

/*
 * иˤƥåݥ󥿤ؤƤϤCCR쥸
 * ѤޤƤϤޤǤΥեåȤ
 *
 * +0:er3
 * +4:er2
 * +8:er1
 *+12:er0
 *  +16:ccr spХ
 */
#define OFFSET_CCR		16


/*
 *  ߥϥɥи
 *
 *  褬reqflgåȤƤΤߤˤ
 *  ߥͥȥ = 0,߶ػ߾,å쥸
 *  ¸֤ǸƤӽФȡ
 */
	.text
ret_int:
	sub.l	er0, er0
	mov.l   er0, @_reqflg             /* reqflg򥯥ꥢ */
	/*
	 *  CPUå֤ˤ롣
	 *lock_flag  true
	 *saved_iipm  γߥޥ
	 *             ʥåѤǤccrIIPM
	 *
	 *  ͥγߤϤǤ˶ػߤƤΤǡlock_flag
	 *  saved_iipm򹹿롥saved_iipmϡγͥ
	 *  ޥʤɽˤꤹ롥
	 *
	 *  λCPUå֤ȤΤϡdispatcherʬȡ
	 *  call_texrtnƤӽФˡCPUå֤ˤʤäƤɬפ
	 *  Ǥ롥
	 */
	mov.b	#1, r0l
	mov.l   er0, @_lock_flag
	mov.b   @(OFFSET_CCR, sp), r1l
	and.b   #H8CCR_INT_MASK_BIT, r1l
	mov.b   r1l, @_saved_iipm

	mov.l	@_p_runtsk, er0		/* er0 <- p_runtsk */
								/*er0ͤret_int_1ǤѤ*/
	/*
	 *  ǥѥåػߤޤϥåɬפʤˤϡǥ
	 *  ѥåƤӽФʤ
	 *  ΥåɬפʤΤϡ㳰롼θƽФɬ
	 *  ʾˡǥѥåɬפʤƤ⡤¸reqflgtrue
	 *  뤿Ǥ롥
	 */
	mov.l	@_dspflg, er2		/* dspflgΥå */
	beq	ret_int_1				/* ǥѥåػߤʤret_int_1 */

	mov.l	@_p_schedtsk, er1	/* er1 <- p_schedtsk */
	cmp.l	er0, er1			/* p_runtsk  p_schedtsk  */
	beq	ret_int_1				/* Ʊʤret_int_1 */

	push.l  er4                 /* 쥸 */
	push.l  er5
	push.l  er6

	mov.l	sp, @(TCB_sp, er0)	/* åݥ󥿤¸ */
	mov.l	#ret_int_r, er1  	/* ¹ԺƳ */
	mov.l	er1, @(TCB_pc, er0)
	bra	dispatcher:16
	/* 8ӥåPCʬǤϤʤᡢ16ӥåȻ */

/*
 *  ߤνиǥǥѥå㤫餳äƤ
 */
ret_int_r:
    pop.l   er6                 /* 쥸 */
    pop.l   er5
	pop.l   er4

	/*
	 *åʤϤή
	 *ˤdispatcherޤret_intäƤΤǡ
	 *er0ˤp_runtskƤƤ롣
	 */
ret_int_1:
			/* 㳰ľ֤Υå */
	mov.b	@(TCB_enatex, er0), r1l
	btst	#TCB_enatex_bit, r1l	/* TCB.enatex=0 -> CCR.Z=1 */
	beq	ret_int_2				/* 㳰ػ߾֤ʤ饸 */
						/* 㳰׵Υå */
						/* texptnTEXPTNuint_t32ӥå */
	mov.l	@(TCB_texptn, er0), er1
	beq	ret_int_2		/* 㳰׵᤬ʤХ */
	jsr	@_call_texrtn	/* 㳰롼ư */

ret_int_2:
	/*
	 *  ߽Υ꥿ˤꡤCPUå֤˰ܹԤ褦
	 *  롥ͥ٥ޥϡRTE̿ˤ긵ͤ뤿ᡤ
	 *  lock_flagfalseˤƤФ褤
	 */
	sub.l   er0, er0
	mov.l   er0, @_lock_flag
									/* 쥸 */
	pop.l   er3                     /*  +0:er3 */
	pop.l   er2                     /*  +4:er2 */
	pop.l   er1                     /*  +8:er1 */
	pop.l   er0                     /* +12:er0 */
	rte


/*
 *  ư
 *
 *  Υ롼ˤϡdispatcherΤߤʬ
 *  ƥ
 *  CPUå
 *  ʥǥΡ˳ͥ٥ޥ
 *  ǥѥåľ
 *  ǸƤӽФ롥
 */

	.globl _start_r
_start_r:
	/*
	 *  CPUå롣
	 *  CPUåե饰򥯥ꥢ
	 *  
	 */
	sub.l   er1, er1
	mov.l   er1, @_lock_flag
	ldc.b   #IIPM_ENAALL, ccr

	mov.l	#_ext_tsk, er2
	push.l	er2
	/*
	 *  ˤϡdispatcherΤߤʬƤΤǡ
	 *  er0ˤp_runtskƤƤ롣
	 */
	mov.l	@(TCB_p_tinib, er0), er2
	mov.l	@(TINIB_task, er2), er1		/* ư */
					/* ĥʥؤΰ*/
	mov.l	@(TINIB_exinf, er2), er0
	jmp	@er1

/*
 *  ͥνλθƽФ
 *
 *ߥå֤ǸƤФ롣
 *󥿥ƥȤڤؤ
 *intnet1
 *åڤؤ
 *exit_kernelʬ
 */
	.globl _call_exit_kernel
_call_exit_kernel:
    mov.b	#1, r1l
    mov.b	r1l, @_intnest
    mov.l 	@_istkpt, sp
    mov.l 	#_exit_kernel, er0
    jmp   	@er0

/*
 *  ԤSILΥåȰ¸
 *ʲƱνԤ
 *	void sil_dly_nse(ulong_t dlytim)
 *	{
 *		dlytim -= SIL_DLY_TIM1;
 *		if (̤0ʲ) {
 *			do {
 *				dlytim -= SIL_DLY_TIM2;
 *			} while (̤0ʲ);
 *		}
 *	}
 */
	.globl _sil_dly_nse
_sil_dly_nse:
	; er0 = dlytim 
	sub.l	#SIL_DLY_TIM1, er0
	ble	sil_dly_nse_2
				/* dlytim < SIL_DLY_TIM1 ʤ롼׽λ */
sil_dly_nse_1:
	sub.l	#SIL_DLY_TIM2, er0
	bgt	sil_dly_nse_1
				/* dlytim > SIL_DLY_TIM2 ʤ롼³ */
sil_dly_nse_2:
	rts

/*************************************************************
  ʲȤΥ󥿡եˤϴޤޤʤȼʬ
 *************************************************************/
/*
 *  ǥեȤγߥϥɥ
 *
 *  ϿƤʤߤȯȸƤӽФ롣
 *  ̾γߤͳƸƤФ롣
 *
 *  ƤФȤξ
 *  åڤؤѤ
 *  ߶ػ
 *  er0-er3Ѥ
 *  r3h٥ֹ
 *
 * ĤΥ쥸ȰԤ
 * C롼default_int_handler()ƤӽФ
 */
#ifndef OMIT_DEFAULT_INT_HANDLER
    .globl  _default_int_handler_entry
_default_int_handler_entry:
	push.l	er4			/* er4er6 */
	push.l	er5
	push.l	er6
	mov.l	sp, er0		/*  1åݥ */
	mov.b	r3h, r1l	/*  2٥ֹ */
	jsr		@_default_int_handler
	pop.l	er6
	pop.l	er5
	pop.l	er4
	rts					/*  и */
#endif

